"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.define = define;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

require("core-js/modules/es.object.to-string.js");

require("core-js/modules/es.promise.js");

require("core-js/modules/es.object.assign.js");

require("core-js/modules/es.array.splice.js");

require("core-js/modules/web.dom-collections.for-each.js");

require("core-js/modules/es.object.keys.js");

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _immer = require("immer");

var _react = require("react");

var _reactDom = require("react-dom");

var useIsomorphicEffect = typeof window === 'undefined' ? _react.useEffect : _react.useLayoutEffect;

var isGenerator = function isGenerator(arg) {
  return arg && 'next' in arg && 'throw' in arg && typeof arg.next === 'function' && typeof arg.throw === 'function';
};

/**
 * Create state object.
 */
function define() {
  return new State();
}

var State = function State() {
  var _this = this;

  this.hasSetup = false;
  this.state = void 0;
  this.context = void 0;
  this.depends = [];
  this.running = false;

  this.setup = /*#__PURE__*/function () {
    var _ref = (0, _asyncToGenerator2.default)( /*#__PURE__*/_regenerator.default.mark(function _callee(state) {
      return _regenerator.default.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _this.hasSetup = true;
              _this.context = {
                state: (0, _immer.createDraft)(state)
              };

              if (!_this.depends.length) {
                _context.next = 6;
                break;
              }

              return _context.abrupt("return", Promise.resolve().then(function () {
                _this.commit();
              }));

            case 6:
              _this.commit();

            case 7:
              return _context.abrupt("return", Promise.resolve());

            case 8:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));

    return function (_x) {
      return _ref.apply(this, arguments);
    };
  }();

  this.update = /*#__PURE__*/function () {
    var _ref2 = (0, _asyncToGenerator2.default)( /*#__PURE__*/_regenerator.default.mark(function _callee2(updater) {
      var ret;
      return _regenerator.default.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              if (!(process.env.NODE_ENV !== 'production')) {
                _context2.next = 3;
                break;
              }

              if (_this.hasSetup) {
                _context2.next = 3;
                break;
              }

              throw new Error('Required to call `setup` first.');

            case 3:
              if (!_this.running) {
                _context2.next = 5;
                break;
              }

              return _context2.abrupt("return", _this.resolve(updater(_this.context)));

            case 5:
              _this.running = true;
              ret = updater(_this.context);

              if (isGenerator(ret)) {
                _context2.next = 13;
                break;
              }

              _this.running = false;

              _this.commit();

              return _context2.abrupt("return", Promise.resolve());

            case 13:
              return _context2.abrupt("return", _this.resolve(ret, true).then(function () {
                _this.running = false;
              }));

            case 14:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2);
    }));

    return function (_x2) {
      return _ref2.apply(this, arguments);
    };
  }();

  this.use = function (select, deps) {
    if (deps === void 0) {
      deps = [];
    }

    if (process.env.NODE_ENV !== 'production') {
      if (!_this.hasSetup) {
        throw new Error('Required to call `setup` first.');
      }
    }

    if (typeof select === 'undefined') {
      select = function select(s) {
        return Object.assign({}, s);
      };
    }

    var selectedRef = (0, _react.useRef)();

    var _useState = (0, _react.useState)(function () {
      return 1;
    }),
        setVersion = _useState[1]; // Listen state changed.


    useIsomorphicEffect(function () {
      var updater = function updater(newState) {
        var selected = select(newState);

        if (!equals(selected, selectedRef.current)) {
          selectedRef.current = selected;
          setVersion(function (v) {
            return v + 1;
          });
        }
      };

      _this.depends.push(updater);

      return function () {
        var idx = _this.depends.indexOf(updater);

        if (idx >= 0) {
          _this.depends.splice(idx, 1);
        }
      };
    }, []); // Listen deps changed.

    (0, _react.useMemo)(function () {
      var selected = select(_this.state);

      if (!equals(selected, selectedRef.current)) {
        selectedRef.current = selected;
      }
    }, deps);
    return selectedRef.current;
  };

  this.get = function (select) {
    if (process.env.NODE_ENV !== 'production') {
      if (!_this.hasSetup) {
        throw new Error('Required to call `setup` first.');
      }
    }

    if (typeof select === 'undefined') {
      select = function select(s) {
        return s;
      };
    }

    return select(_this.state);
  };

  this.resolve = /*#__PURE__*/function () {
    var _ref3 = (0, _asyncToGenerator2.default)( /*#__PURE__*/_regenerator.default.mark(function _callee4(gen, commit) {
      return _regenerator.default.wrap(function _callee4$(_context4) {
        while (1) {
          switch (_context4.prev = _context4.next) {
            case 0:
              if (commit === void 0) {
                commit = false;
              }

              if (isGenerator(gen)) {
                _context4.next = 4;
                break;
              }

              if (commit) {
                _this.commit();
              }

              return _context4.abrupt("return", Promise.resolve());

            case 4:
              _context4.next = 6;
              return new Promise(function (resolve) {
                var next = /*#__PURE__*/function () {
                  var _ref4 = (0, _asyncToGenerator2.default)( /*#__PURE__*/_regenerator.default.mark(function _callee3(gen, r, e) {
                    var current;
                    return _regenerator.default.wrap(function _callee3$(_context3) {
                      while (1) {
                        switch (_context3.prev = _context3.next) {
                          case 0:
                            // Resume suspended generator.
                            current = typeof r !== 'undefined' ? gen.next(r) : typeof e !== 'undefined' ? gen.throw(e) : gen.next(); // Resolve promise with current state when generator has done.

                            if (!current.done) {
                              _context3.next = 3;
                              break;
                            }

                            return _context3.abrupt("return", resolve());

                          case 3:
                            // Wait for promise and then run next.
                            _this.commit();

                            return _context3.abrupt("return", Promise.resolve(current.value).then(function (r) {
                              return next(gen, r, undefined);
                            }, function (e) {
                              return next(gen, undefined, e);
                            }));

                          case 5:
                          case "end":
                            return _context3.stop();
                        }
                      }
                    }, _callee3);
                  }));

                  return function next(_x5, _x6, _x7) {
                    return _ref4.apply(this, arguments);
                  };
                }(); // First run.


                // First run.
                next(gen, undefined, undefined);
              });

            case 6:
              _this.commit();

            case 7:
            case "end":
              return _context4.stop();
          }
        }
      }, _callee4);
    }));

    return function (_x3, _x4) {
      return _ref3.apply(this, arguments);
    };
  }();

  this.commit = function () {
    if (process.env.NODE_ENV === 'development') {
      if (!_this.hasSetup) {
        throw new Error('Required to call `setup` first.');
      }
    }

    var newState = (0, _immer.current)(_this.context.state);

    if (newState !== _this.state) {
      if (process.env.NODE_ENV !== 'production') {
        (0, _immer.finishDraft)(_this.context.state);
      }

      _this.context.state = (0, _immer.createDraft)(newState);
      (0, _reactDom.unstable_batchedUpdates)(function () {
        _this.state = newState;

        _this.depends.forEach(function (dep) {
          dep(newState);
        });
      });
    }
  };
};
/**
 * @license https://github.com/streamich/fast-shallow-equal/blob/master/LICENSE
 */


var equals = function equals(a, b) {
  if (a === b) return true;
  if (!(a instanceof Object) || !(b instanceof Object)) return false;
  var keys = Object.keys(a);
  var length = keys.length;

  for (var i = 0; i < length; i++) {
    if (!(keys[i] in b)) return false;
  }

  for (var _i = 0; _i < length; _i++) {
    if (a[keys[_i]] !== b[keys[_i]]) return false;
  }

  return length === Object.keys(b).length;
};